%--------------------------------------------------------------------------
%               Systems and control theory
%               Prof: Luigi Biagiotti
%               Solution of exercises #5
%--------------------------------------------------------------------------

clear all
close all
clc

Ma = 290;    % kg
Mr = 60;    % kg
K = 20000; % N/m
Kp = 190000; % N/m
b1 = 1000;   % N/m/s
b2 = 10000;   % N/m/s

g = 9.81; %m/s^2

% the vector of the state variables is 
% X = [x1 x2 x3 x4]^T = [Pa Xr pr Xrp]^T

%% 1st point. 

A =[ -b1/Ma  -K   b1/Mr         0;
      1/Ma    0   -1/Mr         0;
      b1/Ma   K   -(b1+b2)/Mr  -Kp;
      0       0   1/Mr          0]

B = [-Ma   1   0;
      0    0   0;
     -Mr  -1  b2;
      0    0  -1]

C = [1/Ma  0   0  0];

sys = ss(A,B,C,0)


%% 2nd point.
Tf = 10;
X0 = [0 0.05 0 0]';
[Y,T,X] = initial(sys,X0,Tf)
figure(1)
plot(T,Y)
grid
xlabel('time [s]')
ylabel('dXma [m/s]')

%% 3rd point.
RispostaForzata = 0;
g = 0;
sim('Sys_LTI_mdl',Tf)
hold on
plot(time, y,'r--')

%% 4th point.
sim('Sys_mdl',Tf)
figure(2)
subplot(2,2,1)
plot(time, x(:,1))
grid on
xlabel('time')
ylabel('p_a')

subplot(2,2,2)
plot(time, x(:,2))
grid on
xlabel('time')
ylabel('X_r')

subplot(2,2,3)
plot(time, x(:,3))
grid on
xlabel('time')
ylabel('p_r')

subplot(2,2,4)
plot(time, x(:,4))
grid on
xlabel('time')
ylabel('X_{rp}')

%% 5th point.
g = 9.81;
RispostaForzata = 1;
X0 = [0 0.05 0 0]';
sim('Sys_mdl',Tf)
figure(3)
plot(time,dXs)
grid on
hold on
plot(time,y,'r--')
xlabel('time [s]')
ylabel('dX_s, dX_{ma} [m/s]')
legend('dX_s','dX_{ma}')
